<?PHP
session_start();
// sucht daten zu einer ISBN-Nummer bei amazon heraus

unset($_SESSION['seiten']);
unset($_SESSION['verlag']);
unset($_SESSION['sprache']);
unset($_SESSION['isbn10']);
unset($_SESSION['isbn13']);
unset($_SESSION['original_titel']);
unset($_SESSION['groesse']);
unset($_SESSION['titel']);
unset($_SESSION['bildlink']);
unset($_SESSION['autor']);

function preview($var)
{
   echo "<br><pre>";
   print_r($var);
   echo "</pre><br>";
}

function unicode_to_Utf8($string)
{
      $string = str_replace('%C4', '%C3%84', $string);
      $string = str_replace('%D6', '%C3%96', $string);
      $string = str_replace('%DC', '%C3%9C', $string);
      $string = str_replace('%E4', '%C3%A4', $string);
      $string = str_replace('%F6', '%C3%B6', $string);
      $string = str_replace('%FC', '%C3%BC', $string);
      return $string;
}

function parse_infopage($isbn="")
{
    global $bildchen;

    // Bindestriche entfernen
    $isbn = str_replace('-','',$isbn);
    $such_url = 'http://www.amazon.de/s/ref=nb_sb_noss?__mk_de_DE=ÅMÅŽÕÑ&url=search-alias%3Daps&field-keywords='.$isbn;
    $info = file_get_contents($such_url);
    $werte = explode('result_0',$info);

    if(isset($werte[0]) AND ($werte[0] != ""))
    {
        if(stristr($werte[0],'<a class="a-link-normal a-text-normal" '))
        {
            $ergebnis_a = explode('<a class="a-link-normal a-text-normal" ',$werte[1]);
        }
        else
        {
            $ergebnis_a = explode('<div class="image">',$werte[1]);
        }
    }
    else
    {
        $ergebnis_a = array();
    }

    if(!isset($ergebnis_a[0])) return false;

    $ergebnis_b = explode('<img src="',$ergebnis_a[0]);
    $ergebnis_url = explode('" ', $ergebnis_b[1]);

    // bidchen url
    $bildurl = $ergebnis_url[0];

    $ergebnis_c = explode('<a class="a-link-normal a-text-normal" href="',$ergebnis_b[0]);
    $ergebnis = str_replace('">','',$ergebnis_c[1]);

    if(isset($bildurl) and ($bildurl != ""))
    {
        $bildchen = '<img src="'.$bildurl.'" style="width:150px; border:1px solid silver;">';
    }

    else
    {
        $bildchen = "";
    }
    return trim($ergebnis);
}

function parse_ergebnispage($url="")
{
    global $buchtitel, $autor, $prod_besch;

    $info = file_get_contents($url);
    $werte = explode('<h2>Produktinformation</h2>',$info);
    $pbeschr = explode('<h2>Produktbeschreibungen</h2>', $info);


    if(isset($pbeschr[1]))
    {
        $pb = explode(' <div class="productDescriptionWrapper">',$pbeschr[1]);
        $prod_besch = explode('<div class="emptyClear">',$pb[1]);
    }
    else
    {
        $prod_besch[0] = '';
    }
    // autor extrahieren

    $au_tor = explode('(Autor)',$werte[0]);

    @$tor = explode('<td id="',$au_tor[0]);
    @$tor = explode('<span class="a-size-medium">',$tor[1]);

    //~ $tor = explode('</a>',$tor[0]);
    //~ $au_tor = explode('<a href',$tor[0]);
    //~ @$tor = explode('>',$au_tor[1]);

    @$autor = my_utf8_encode(trim($tor[1]));

    // Buchtitel heraussuchen
    $buch_titel = explode('<meta name="title" content="',$werte[0]);
    $buch_titel = str_replace('" />','',$buch_titel);

    $btitel = explode(':',$buch_titel[1]);
    $buchtitel = ($btitel[0]);

    // Buchinformationen heraussuchen
    $ergebnis_a = explode('Durchschnittliche Kundenbewertung', $werte[1]);
    $bla = strip_tags($ergebnis_a[0]);

    // den ganzen Mist entfernen
    for($i = 1; $i < 10; $i++)
    {
        $bla = str_replace("\n\n","\n",$bla);
    }

    $bname = explode('/',$url);
    $bla = $bname[3].$bla;
    $bla = explode("\n",$bla);

    for($f = 0; $f < count($bla); $f++)
    {
        if(trim($bla[$f]) == "") continue;
        $bla[$f] = trim($bla[$f]);
        $bla[$f] = str_replace('&nbsp;','',$bla[$f]);
        $infos[] = urldecode(unicode_to_Utf8($bla[$f]));
    }

    return $infos;
}

function make_data($text)
{
    $m = explode(':',trim($text));
    $m = array_pad($m,2,"");

    if(stristr($m[1],"seiten") == TRUE)
    {
        $b = explode(" ",$m[1]);
        $_SESSION['seiten'] = trim($b[1]);
    }

    if(stristr($m[0],"verlag") == TRUE)
    {
        $_SESSION['verlag'] = trim($m[1]);
    }

    if(stristr($m[0],"sprache") == TRUE)
    {
        $_SESSION['sprache'] = trim($m[1]);
    }

    if(stristr($m[0],"isbn-10") == TRUE)
    {
        $_SESSION['isbn10'] = trim($m[1]);
    }

    if(stristr($m[0],"isbn-13") == TRUE)
    {
        $_SESSION['isbn13'] = trim($m[1]);
    }
    if(stristr($m[0],"originaltitel") == TRUE)
    {
        $_SESSION['original_titel'] = trim($m[1]);
    }

    if(stristr($m[0],"cm") == TRUE)
    {
        $_SESSION['groesse'] = trim($m[0]);
    }
}

function my_utf8_encode($text, $do=0)
{
    if($do == 1)
    {
        return utf8_encode($text);
    }
    else
    {
        return $text;
    }
}

if(isset($_GET['isbnnummer']) and ($_GET['isbnnummer'] != ""))
{
    $link = parse_infopage($_GET['isbnnummer']);

    if($link != "")
    {
        $inhalt = parse_ergebnispage($link);

        if(count($inhalt) >= 1)
        {
            $buchtitel = strip_tags($buchtitel);
            $autor = strip_tags($autor);

            $_SESSION['titel'] = $buchtitel;
            $_SESSION['autor'] = $autor;
            $_SESSION['bildlink'] = htmlspecialchars($bildchen);


            for($i = 0; $i < count($inhalt); $i++)
            {
                $data = make_data(my_utf8_encode(trim($inhalt[$i])));
            }
        }
    }

    if($_GET['show'] == 1)
    {
        echo "<br><br><pre>";
        print_r($inhalt);
        echo "<br><br>";
        echo '$_SESSION'."<br>";
        print_r($_SESSION);
        echo "</pre>";
    }

    if($_GET['show'] == 2)
    {
        echo "<pre>";

        $keys = array_keys($_SESSION);

        for($i = 0; $i < count($_SESSION); $i++)
        {
            echo $keys[$i].":".$_SESSION[$keys[$i]]."<br>";
        }
        echo "</pre>";
    }

    if($_GET['show'] == 3)
    {
        echo "<br>\n<br>\n<pre>\n";
       
        for($i = 0; $i < count($inhalt); $i++)
        {
            echo '['.$i.']'.$inhalt[$i]."\n";
        }
        
        echo "<br>\n<br>\n";        
        $keys = array_keys($_SESSION);
        for($i = 0; $i < count($_SESSION); $i++)
        {
            echo '$_SESSION[\''.$keys[$i].'\']'.trim(strip_tags($_SESSION[$keys[$i]]))."\n";
        }
        echo "</pre>\n";
        
        $blabla = implode("\n",$inhalt);
        
        preview($blabla);
        echo "<br>\n";        
        echo $blabla."\n";
        echo "<br>\n";                
    }
}

else
{
    ?>

    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
    <html>
    <head>
      <meta http-equiv="content-type" content="text/html; charset=UTF-8">
      <link rel="Shortcut Icon" href="http://www.mn-portal.at/mnlogo.jpg">
      <title>ISBN</title>
    </head>
    <body>
    <form method="POST" action="<?=$_SERVER['PHP_SELF']?>">
    <input type="text" name="isbn">
    <input type="submit" name="submit" value="suchen">
    </form>
    <?PHP

    echo "<div>\n";
    if(isset($_POST['isbn']) and ($_POST['isbn'] != ""))
    {

        $link = parse_infopage($_POST['isbn']);

        $inhalt = array();
        if($link != "")
        {
            $inhalt = parse_ergebnispage($link);
        }

        if(count($inhalt) > 1)
        {

            $buchtitel = strip_tags($inhalt[0]);
            $autor = strip_tags($autor);
            $prod_besch[0] = strip_tags($prod_besch[0]);

            $_SESSION['titel'] = $inhalt[0];
            $_SESSION['autor'] = $autor;
            $_SESSION['bildlink'] = htmlspecialchars($bildchen);
            $_SESSION['buchinfos'] = trim($prod_besch[0]);

            echo "<div style=\"float:left; width:160px\"><a href=\"".$link."\" target=\"_BLANK\">".htmlspecialchars_decode($_SESSION['bildlink'])."</a></div>\n";

            echo "<div style=\"margin-top:30px;\">\n<pre>\n";
            echo "Titel: ".$buchtitel."<br>";
            echo "Autor: ".$autor."<br>\n";

            for($i = 1; $i < count($inhalt); $i++)
            {

                $info = explode(':',$inhalt[$i]);
                $info = array_pad($info,2,"");


                if(trim($info[1]) == "")
                {
                    if(stristr($info[0],'gewicht') == TRUE) continue;
                    echo my_utf8_encode(trim($info[0]))."<br>";
                }
                else
                {
                    echo $info[0]." :".my_utf8_encode(trim($info[1]))."<br>";
                }

            }

            echo "</pre>\n</div>\n";
            // als Datenbestand aufarbeiten
            for($i = 1; $i < count($inhalt); $i++)
            {
                $data = make_data(my_utf8_encode(trim($inhalt[$i])));
            }

            if($prod_besch[0] != "")
            {
                echo '<br><div style="width:50%; border:1px solid black; padding:1em;height:150px; overflow: auto;text-align: justify;"><span style="font-size:10pt;">'.my_utf8_encode($prod_besch[0])."</span></div>";
            }
        }
        else
        {
            echo "Kein Ergebnis";
        }
        echo '<br><hr><br>http://mn-portal.at/isbn.php?isbnnummer='.$_POST['isbn'].'&show=[1-3]&nbsp;&nbsp;&nbsp;&nbsp;bereitet den Inhalt als Text auf.<br><br>';
        echo '<a href="http://mn-portal.at/isbn.zip">isbn.php als Zip</a>';
        echo "</div>\n</body>\n</html>";
    }
}
